package com.maintain.business.listener;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.maintain.business.domain.ErpWarehouse;
import com.maintain.business.domain.vo.ErpWarehouseVo;
import com.maintain.business.mapper.ErpWarehouseMapper;
import com.maintain.common.core.domain.entity.SysDept;
import com.maintain.common.excel.ExcelListener;
import com.maintain.common.excel.ExcelResult;
import com.maintain.common.exception.ServiceException;
import com.maintain.common.helper.LoginHelper;
import com.maintain.common.utils.ValidatorUtils;
import com.maintain.common.utils.spring.SpringUtils;
import com.maintain.system.mapper.SysDeptMapper;
import lombok.extern.slf4j.Slf4j;

import java.util.List;

/**
 * 站点仓库自定义导入
 *
 * @author liushuai
 */
@Slf4j
public class ErpWarehouseImportListener extends AnalysisEventListener<ErpWarehouseVo> implements ExcelListener<ErpWarehouseVo> {

    private final ErpWarehouseMapper warehouseMapper;
    private final SysDeptMapper deptMapper;

    private final Boolean isUpdateSupport;

    private int successNum = 0;
    private int failureNum = 0;
    private final StringBuilder successMsg = new StringBuilder();
    private final StringBuilder failureMsg = new StringBuilder();

    public ErpWarehouseImportListener(Boolean isUpdateSupport) {
        this.warehouseMapper = SpringUtils.getBean(ErpWarehouseMapper.class);
        this.deptMapper = SpringUtils.getBean(SysDeptMapper.class);
        this.isUpdateSupport = isUpdateSupport;
    }

    @Override
    public void invoke(ErpWarehouseVo groupVo, AnalysisContext context) {
        LambdaQueryWrapper<ErpWarehouse> warehouseVoLambdaQueryWrapper = new LambdaQueryWrapper<>();
        warehouseVoLambdaQueryWrapper.eq(ErpWarehouse::getCode, groupVo.getCode()).eq(ErpWarehouse::getName, groupVo.getName());
        ErpWarehouse warehouse = this.warehouseMapper.selectOne(warehouseVoLambdaQueryWrapper);
        try {
            // 验证是否存在这个班组
            if (ObjectUtil.isNull(warehouse)) {
                warehouse = BeanUtil.toBean(groupVo, ErpWarehouse.class);
                ValidatorUtils.validate(warehouse);
                LambdaQueryWrapper<SysDept> deptLambdaQueryWrapper = new LambdaQueryWrapper<>();
                deptLambdaQueryWrapper.eq(SysDept::getDeptName, warehouse.getDeptName());
                SysDept sysDept = deptMapper.selectOne(deptLambdaQueryWrapper);
                if (sysDept == null) {
                    SysDept dept = new SysDept();
                    dept.setParentId(100L);
                    dept.setAncestors("0,100");
                    dept.setOrderNum(1);
                    dept.setDeptName(warehouse.getDeptName());
                    dept.setStatus("0");
                    dept.setDelFlag("0");
                    if (deptMapper.insert(dept) > 0) {
                        warehouse.setDeptId(dept.getDeptId());
                        warehouse.setDeptName(dept.getDeptName());
                    }
                }else {
                    warehouse.setDeptId(sysDept.getDeptId());
                    warehouse.setDeptName(sysDept.getDeptName());
                }
                warehouse.setCreateDeptId(LoginHelper.getDeptId());
                warehouseMapper.insert(warehouse);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、仓库").append(warehouse.getName()).append(" 导入成功");
            } else if (isUpdateSupport) {
                Long groupId = warehouse.getId();
                warehouse = BeanUtil.toBean(warehouse, ErpWarehouse.class);
                warehouse.setId(groupId);
                ValidatorUtils.validate(warehouse);
                warehouseMapper.updateById(warehouse);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、仓库 ").append(warehouse.getName()).append(" 更新成功");
            } else {
                failureNum++;
                failureMsg.append("<br/>").append(failureNum).append("、仓库 ").append(warehouse.getName()).append(" 已存在");
            }
        } catch (Exception e) {
            failureNum++;
            String msg = "<br/>" + failureNum + "、仓库 " + warehouse.getName() + " 导入失败：";
            failureMsg.append(msg).append(e.getMessage());
            log.error(msg, e);
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {

    }

    @Override
    public ExcelResult<ErpWarehouseVo> getExcelResult() {
        return new ExcelResult<ErpWarehouseVo>() {

            @Override
            public String getAnalysis() {
                if (failureNum > 0) {
                    failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
                    throw new ServiceException(failureMsg.toString());
                } else {
                    successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
                }
                return successMsg.toString();
            }

            @Override
            public List<ErpWarehouseVo> getList() {
                return null;
            }

            @Override
            public List<String> getErrorList() {
                return null;
            }
        };
    }
}
